Package: acnr
Type: Package
Title: Annotated Copy-Number Regions
Version: 1.0.0
Date: 2017-04-15
Authors@R: c(person("Morgane", "Pierre-Jean", role = c("aut", "cre"),
                     email = "morgane.pierrejean@genopole.cnrs.fr"),
              person("Pierre", "Neuvial", role = "aut"))
Description: Provides SNP array data from different types of
    copy-number regions. These regions were identified manually by the authors
    of the package and may be used to generate realistic data sets with known
    truth.
License: LGPL (>= 2.1)
Depends: R (>= 2.10),
Suggests: R.utils, knitr, rmarkdown, testthat
RoxygenNote: 5.0.1
VignetteBuilder: knitr
URL: https://github.com/mpierrejean/acnr
BugReports: https://github.com/mpierrejean/acnr/issues
NeedsCompilation: no
Packaged: 2017-04-18 08:34:55 UTC; mpierre-jean
Author: Morgane Pierre-Jean [aut, cre],
  Pierre Neuvial [aut]
Maintainer: Morgane Pierre-Jean <morgane.pierrejean@genopole.cnrs.fr>
Repository: CRAN
Date/Publication: 2017-04-18 09:58:15 UTC
Built: R 4.6.0; ; 2026-04-26 09:27:53 UTC; unix

# acnr: annotated copy-number regions

This data package contains SNP array data from different platforms (Affymetrix and Immumina) and different types of copy-number regions. These regions were identified manually by the authors of the package and may be used to generate realistic data sets with known truth.

Currently the `acnr` package  contains three data sets curated from GEO:

    > library("acnr")
    > listDataSets()
    [1] "GSE11976_CRL2324" "GSE13372_HCC1143" "GSE29172_H1395"  

This package was initially built to serve as a data package for the [jointseg](https://github.com/mpierrejean/jointseg) package.

## Software status

| Resource:     | CRAN        | Travis CI      | Appveyor         |
| ------------- | ------------------- | -------------- | ---------------- |
| _Platforms:_  | _Multiple_          | _Linux & OS X_ | _Windows_        |
| R CMD check   | <a href="https://cran.r-project.org/web/checks/check_results_acnr.html"><img border="0" src="http://www.r-pkg.org/badges/version/acnr" alt="CRAN version"></a> || <a href="https://travis-ci.org/mpierrejean/acnr"><img src="https://travis-ci.org/mpierrejean/acnr.svg" alt="Build status"></a> | <a href="https://ci.appveyor.com/project/mpierrejean/acnr"><img src="https://ci.appveyor.com/api/projects/status/github/mpierrejean/acnr?svg=true" alt="Build status"></a> |
| Test coverage | | <a href="https://codecov.io/gh/mpierrejean/acnr"><img src="https://codecov.io/gh/mpierrejean/acnr/branch/master/graph/badge.svg" alt="Coverage Status"/></a> | |

## Required local file structure:
## (see http://aroma-project.org/setup for details)
## 
## annotationData/
##   chipTypes/
##     GenomeWideSNP_6/
##       GenomeWideSNP_6,Full.CDF
##       GenomeWideSNP_6,Full,monocell.CDF
##       GenomeWideSNP_6,Full,na31,hg19,HB20110328.ufl
##       GenomeWideSNP_6,Full,na31,hg19,HB20110328.ugp
##       GenomeWideSNP_6,HB20080710.acs

library("aroma.affymetrix")
log <- verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
options(digits=4) # Don't display too many decimals.

## Verifying annotation data files
cdf <- AffymetrixCdfFile$byChipType("GenomeWideSNP_6", tags="Full")
print(cdf)

gi <- getGenomeInformation(cdf)
print(gi)

si <- getSnpInformation(cdf)
print(si)

acs <- AromaCellSequenceFile$byChipType(getChipType(cdf, fullname=FALSE))
print(acs)

## Do not continue beyond this point if any of the above fails!

sf <- system.file("preprocessing/GSE11976/01.defineCopyNumberSegments.R", package="acnr")
source(sf)
str(regDat)

dataSet <- "GSE11976"
chipType <- "HumanCNV370v1"

datPath <- "wholeGenomeData"; ## A symbolic link to "/home/share/Data/wholeGenomeData"
datPath <- Arguments$getReadablePath(datPath);
ds <- sprintf("%s,BeadStudio", dataSet)
path <- file.path(datPath, ds, chipType);
path <- Arguments$getReadablePath(path);

## read
fileName <- sprintf("CRL2324_dilutionSeries.rds", dataSet)
pathname <- file.path(path, fileName)
datI <- readRDS(pathname)

datI$posMb <- datI$position/1e6;
nms <- names(datI)[grep("^LRR", names(datI))]
pcts <- gsub("LRR_([0-9]+)", "\\1", nms)

sampleName <- "CRL2324"
savPath <- "cnRegionData"
savPath <- Arguments$getWritablePath(savPath)
path <- file.path(savPath, ds, chipType);
path <- Arguments$getWritablePath(path)

for (rr in 1:nrow(regDat)) {
    chr <- regDat[rr, "chr"]
    reg <- c(regDat[rr, "begin"], regDat[rr, "end"])
    type <- regDat[rr, "type"]
    datCC <- subset(datI, chromosome==chr)
    datRR <- subset(datCC, posMb>=reg[1] & posMb<=reg[2])
    opos <- order(datRR$posMb)
    datRRo <- datRR[opos, ]
    datRRo <- na.omit(datRRo)
        
    for(pp in pcts){
        cols <- c(sprintf("LRR_%s", pp), sprintf("BAF_%s", pp), "muN")
        datSS <- na.omit(datRRo[, cols])
        names(datSS) <- c("c","b","genotype")
        datSS$c <- 2^(datSS$c + 1)
        tgb <- tan(datSS$b*pi/2)
        datSS$b <- tgb/(1+tgb)
        datSS <- round(datSS, 3)
        filename <- sprintf("%s,%s,%s.rds", sampleName, pp, type)
        pathname <- file.path(path,filename)
        saveRDS(datSS, file=pathname)
    }
}

library("R.utils");
library("aroma.light");

dataSet <- "GSE29172"
chipType <- "GenomeWideSNP_6"

if (FALSE) {
    ## Define CN regions:
    rpn <- sprintf("preprocessing/%s/05.defineCopyNumberSegments.R", dataSet)
    pn <- system.file(rpn, package="acnr")
    file.exists(pn)
    source(pn)
    str(regDat)
}

datPath <- "wholeGenomeData";
datPath <- Arguments$getReadablePath(datPath);

regPath <- "png/regions"
regPath <- file.path(regPath, dataSet)
regPath <- Arguments$getWritablePath(regPath)

savPath <- "cnRegionData"
savPath <- Arguments$getWritablePath(savPath)
opath <- file.path(savPath, sprintf("%s,ASCRMAv2", dataSet), chipType);
opath <- Arguments$getWritablePath(opath)

path <- file.path(datPath, sprintf("%s,ASCRMAv2", dataSet), chipType);
path <- Arguments$getReadablePath(path);

patt <- "H1395vsBL1395,([0-9]+).rds"
filenames <- list.files(path, pattern=patt)
pathnames <- file.path(path, filenames)
rm(path)
pct <- as.numeric(gsub(patt, "\\1", filenames))

for (kk in seq(along=pct)) {
    pathname <- pathnames[kk]
    sampleName <- gsub("(.*)\\.rds$", "\\1", filenames[kk])
    
    print(sampleName)
    
    dat <- loadObject(pathname)
    dat$posMb <- dat$x/1e6;
    rm(pathname)
    
    ## run TumorBoost
    betaTN <- normalizeTumorBoost(betaT=dat$betaT,betaN=dat$betaN)
    muN <- callNaiveGenotypes(dat$betaN)
    dat.norm <- cbind(dat, muN, betaTN, b=2*abs(betaTN-1/2))
    
    bkp <- function(pos) abline(v=pos, col=5, lwd=2)
    
    for (rr in 1:nrow(regDat)) {
        chr <- regDat[rr, "chr"]
        reg <- c(regDat[rr, "begin"], regDat[rr, "end"])
        type <- regDat[rr, "type"]
        print(type)
        
        datCC <- subset(dat.norm, chromosome==chr)
        minR <- reg[1]
        maxR <- reg[2]
        
        datRR <- subset(datCC, posMb>minR & posMb<maxR)
        str(datRR)
        
        opos <- order(datRR$x)
        datRRo <- datRR[opos, ]
        
        datSS <- datRRo[, c("CT", "betaTN", "muN", "betaT", "betaN")]
        names(datSS) <- c("c","b","genotype", "bT", "bN")
        datSS <- round(datSS, 3)
        
        filename <- sprintf("%s,%s.rds", sampleName, type)
        pathname <- file.path(opath, filename)
        saveRDS(datSS, file=pathname)
    }
}

## Adapted from http://aroma-project.org/vignettes/PairedPSCBS-lowlevel

dataSet <- "GSE29172"
dataSetN <- "GSE26302"
chipType <- "GenomeWideSNP_6"

tags <- "ACC,ra,-XY,BPN,-XY,AVG,FLN,-XY"
dsT <- AromaUnitTotalCnBinarySet$byName(dataSet, tags=tags, chipType = chipType)
length(dsT)

dsN <- AromaUnitTotalCnBinarySet$byName(dataSetN, tags=tags, chipType = chipType)
length(dsN)

fnt <- function(names, ...) {
    pct <- gsub(".*mix([0-9]+).*", "\\1", names)
}

setFullNamesTranslator(dsT, fnt)
fullNames <- getFullNames(dsT)

## Naming
tumorName <- "H1395"
normalName <- "BL1395"

## Extract (total,beta) estimates for the tumor-normal pair
dataT <- extractPSCNArray(dsT);
str(dataT);
dataN <- extractPSCNArray(dsN);
str(dataN);

## Get (chromosome, position) annotation data
ugp <- getAromaUgpFile(dsT);
chromosome <- ugp[,1,drop=TRUE];
x <- ugp[,2,drop=TRUE];

## Total intensities and Allele B fractions for the normal
thetaN <- dataN[,"total", 1];
betaN <- dataN[,"fracB", ];

datPath <- "wholeGenomeData";
## A symbolic link to "/home/share/Data/wholeGenomeData"
datPath <- Arguments$getWritablePath(datPath);
chipType <- getChipType(dsT, full=FALSE)
dsName <- getName(dsT)
dataSet <- sprintf("%s,ASCRMAv2", dataSet)
path <- file.path(datPath, dataSet, chipType);
path <- Arguments$getWritablePath(path);


idxs <- seq(length=dim(dataT)[3])
for (ss in idxs) {
    pct <- dimnames(dataT)[[3]][ss]
    print(pct)

    pairName <- sprintf("%svs%s,%s", tumorName, normalName, pct)

    ## Total CNs for the tumor relative to the matched normal
    CT <- 2 * dataT[,"total", ss] / thetaN;
    
    ## Allele B fractions for the tumor
    betaT <- dataT[,"fracB", ss];
    
    ## Setup data structure
    df <- data.frame(chromosome=chromosome, x=x, CT=CT, betaT=betaT, betaN=betaN);

    dfC <- subset(df, !is.na(df$chromosome) & !is.na(df$x))
    str(dfC)
    
    ## save  
    fileName <- sprintf("%s.rds", pairName)
    pathname <- file.path(path, fileName)
    saveRDS(dfC, file=pathname)

    if (FALSE) {    
        ## chromosome by chromosome
        for (cc in 1:24) {
            print(cc)
            fileName <- sprintf("%s,chr=%02d.rds", pairName, cc)
            pathname <- file.path(path, fileName)
            saveRDS(dfC, file=pathname)
            
            datCC <- subset(dfC, chromosome==cc)
            o <- order(datCC$x)
            datCC <- datCC[o, ]
            str(datCC)
            save(datCC, file=pathname)
        }
    }
}

##########################################################################
# Allele-specific CRMAv2
##########################################################################
library("aroma.affymetrix");
verbose <- Arguments$getVerbose(-8, timestamp=TRUE);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Setup
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dataSet <- "GSE13372";
chipType <- "GenomeWideSNP_6,Full";

cdf <- AffymetrixCdfFile$byChipType("GenomeWideSNP_6", tags="Full")
print(cdf)

csR <- AffymetrixCelSet$byName(dataSet, chipType=chipType, cdf=cdf);
print(csR);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AS-CRMAv2
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

## Extract only one tumor and two matching normals
nms <- c(T="GSM337641", N="GSM337662", R="GSM337663")
idxs <- indexOf(csR, nms)
csE <- extract(csR, idxs)

res <- doASCRMAv2(csE, verbose=verbose)

# nn <- names(csR)
# resR <- doASCRMAv2(csR[which(nn=="GSM337641")], verbose=verbose);
# resN <- doASCRMAv2(csR[which(nn=="GSM337663")], verbose=verbose);
# resRef <- doASCRMAv2(csR[which(nn=="GSM337662")], verbose=verbose);

## ----setup, include=FALSE------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)

## ---- message=FALSE------------------------------------------------------
library("acnr")
library("R.utils")

## ------------------------------------------------------------------------
dataSets <- listDataSets()
dataSet <- dataSets[2]
print(dataSet)

tfs <- listTumorFractions(dataSet)
tf <- tfs[1]
(tf)

dat <- loadCnRegionData(dataSet, tumorFraction=tf)
region <- as.factor(dat$region)

## ------------------------------------------------------------------------
x <- dat$c
rm(dat)

## ---- fig.width=4, fig.height=2, message=FALSE---------------------------
lim <- c(0, 0.05)
res <- sapply(levels(region), function (rr){
    xTrue <- x[which(region==rr)]
    xResamp <- sample(xTrue)
    mar <- c(2, 2, 1, 0)+0.2
    par(mar=mar)
    acf(xTrue, ylim=lim)
    mtext(sprintf("Original data: %s", rr), side=3)
    acf(xResamp, ylim=lim)
    mtext(sprintf("Resampled data: %s", rr), side=3)
})

## ---- results='asis'-----------------------------------------------------
tst <- "Ljung-Box"
lag <- 20
res <- sapply(levels(region), function (rr){
    xTrue <- x[which(region==rr)]
    len <- length(xTrue)
    xResamp <- sample(xTrue)
    bt <- Box.test(xTrue, lag=lag, type=tst)
    br <- Box.test(xResamp, lag=lag, type=tst)
    c("Original data"=bt$p.value, "Resampled data"=br$p.value, "Region size"=len)
})
cpt <- sprintf("$p$-values of the %s auto-correlation test (lag=%s)", tst, lag)
knitr::kable(t(res), caption=cpt)

## ------------------------------------------------------------------------
plot(sort(res[2, ]), ylab="p-value", xlab="rank", main="sorted p-values", pch=19, col=3, ylim=c(0,1))
points(sort(res[1, ]), pch=19, col=1)
abline(a=0, b=1/ncol(res), lty=2)

## ---- results='asis'-----------------------------------------------------
tst <- "Ljung-Box"
lag <- 20
maxSize <- 2000
res2 <- sapply(levels(region), function (rr){
    xTrue <- head(x[which(region==rr)], maxSize)
    len <- length(xTrue)
    xResamp <- sample(xTrue)
    bt <- Box.test(xTrue, lag=lag, type=tst)
    br <- Box.test(xResamp, lag=lag, type=tst)
    c("Original data"=bt$p.value, "Resampled data"=br$p.value, "Region size"=len)
})
cpt <- sprintf("$p$-values of the %s auto-correlation test (lag=%s) for regions of size <= %s", tst, lag, maxSize)
knitr::kable(t(res2), caption=cpt)

## ------------------------------------------------------------------------
plot(sort(res2[2, ]), ylab="p-value", xlab="rank", main="sorted p-values", pch=19, col=3, ylim=c(0,1))
points(sort(res2[1, ]), pch=19, col=1)
abline(a=0, b=1/ncol(res), lty=2)

## ------------------------------------------------------------------------
sessionInfo()

library("R.utils")
sf <- system.file("preprocessing/GSE11976/01.defineCopyNumberSegments.R", package="acnr")
source(sf)
str(regDat)

regPath <- "cnRegionData";
regPath <- Arguments$getReadablePath(regPath);

dataSet <- "GSE11976,BAF"
chipType <- "HumanCNV370v1"

path <- file.path(regPath, dataSet, chipType);
path <- Arguments$getReadablePath(path);

sampleName <- "CRL2324"
pattern <- sprintf("%s,([0-9]+),\\(([0-9]),([0-9])\\).rds", sampleName)
filenames <- list.files(path, pattern=pattern)
pcts <- unique(gsub(pattern, "\\1", filenames))

savPath <- Arguments$getWritablePath("inst/extdata")

types <- regDat[["type"]]
datList <- list()

toExclude <- c("23", "45", "47") ## tumorFractions to exclude (clear inconsistencies between reported fraction and experimental results, see Table 3 in Staaf (2008))

for (pct in pcts) {
    if (pct %in% toExclude) {
        next;
    }
    print(pct)
    pattern <- sprintf("%s,%s,(.*).rds", sampleName, pct)
    filenames <- list.files(path, pattern=pattern)
    types <- gsub(pattern, "\\1", filenames)
    
    pathnames <- file.path(path, filenames)
    for (tt in seq(along=types)) {
        pathname <- pathnames[tt]
        typ <- types[tt]
        dat <- readRDS(pathname)
        dat$region <- typ
        dat$cellularity <- as.numeric(pct)/100
        tag <- sprintf("%s,%s", pct, typ)
        datList[[tag]] <- dat
    } 
}
dat <- do.call("rbind", datList)
rownames(dat) <- NULL
str(dat)

dsName <- "GSE11976_CRL2324"
filename <- sprintf("%s.rds", dsName)
pathname <- file.path(savPath, filename)
saveRDS(dat, file=pathname)

path <- system.file("testScripts/R", package="aroma.affymetrix");
pathname <- file.path(path, "downloadUtils.R");
source(pathname);

verbose && enter(verbose, "Downloading raw data");



##########################################################################
# Data set:
# GSE13372
#   GenomeWideSNP_6/
#    GSM337641.CEL, ..., GSM337708.CEL [68]
#
# Overall design:
#  21 replicates of HCC1143 (breast ductal carcinoma), 21 replicates of
#  HCC1143BL (matched normal), 13 replicates of HCC1954 (breast ductal
#  carcinoma), 11 replicates of HCC1954BL (matched normal), 1 replicate of
#  NCI-H2347 (lung adenocarcinoma), 1 replicate of NCI-H2347BL (matched normal)
#
# URL: http://www.ncbi.nlm.nih.gov/projects/geo/query/acc.cgi?acc=GSE13372
##########################################################################
dataSet <- "GSE13372";
chipType <- "GenomeWideSNP_6";

verbose && cat(verbose, "Data set: ", dataSet);

ds <- downloadGeoRawDataSet(dataSet, chipType=chipType, 
                   chipTypeAliases=c("GenomeWideEx_6"="GenomeWideSNP_6"));
print(ds);
## AffymetrixCelSet:
## Name: GSE13372
## Tags:
## Path: rawData/GSE13372/GenomeWideSNP_6
## Platform: Affymetrix
## Chip type: GenomeWideSNP_6
## Number of arrays: 68
## Names: GSM337641, GSM337642, GSM337643, ..., GSM337708 [68]
## Time period: 2007-05-17 16:13:28 -- 2008-09-11 21:06:39
## Total file size: 4480.08MB
## RAM: 0.07MB


verbose && exit(verbose);

pctAffy <- c(100,70,50,30)
pctIllu <- c(100,79,50,34)
for(tf in 1:4){
    affy <- loadCnRegionData("GSE29172", tumorFraction=pctAffy[tf]/100)
    illu <- loadCnRegionData("GSE11976", tumorFraction=pctIllu[tf]/100)
    nb <- 2*max(table(illu$region))
    tt <- do.call(rbind,
                  lapply(unique(affy$region), function(rr){
                      dat=subset(affy, region==rr)
                      idx=sample(nrow(dat), nb)
                      dat[idx,]
                  })
                  )
    readRDS(tt, sprintf("GenomeWideSNP_6/GSE29172,ASCRMAv2,H1395vsBL1395,%s,cnRegions.rds",pctAffy[tf]))	
}

library("R.utils");
library("aroma.light");
library("PSCBS")

datPath <- "wholeGenomeData";
datPath <- Arguments$getReadablePath(datPath);

dataSet <- "GSE29172,ASCRMAv2"
chipType <- "GenomeWideSNP_6"
path <- file.path(datPath, dataSet, chipType);
path <- Arguments$getReadablePath(path);

filenames <- list.files(path, pattern="H1395vsBL1395,([0-9]+).rds")
sampleNames <- gsub("(.*)\\.rds$", "\\1", filenames)

pathnames <- file.path(path, filenames)

figPath <- "png"
figPath <- Arguments$getWritablePath(figPath)

figForce <- FALSE;

for (kk in seq(along=pathnames)) {
    sampleName <- sampleNames[kk];
    print(sampleName)
    pathname <- pathnames[kk];
    
    dat <- loadObject(pathname)
    dat$posMb <- dat$x/1e6;
    rm(pathname)

    ## run TumorBoost
    betaTN <- normalizeTumorBoost(betaT=dat$betaT,betaN=dat$betaN)
    muN <- callNaiveGenotypes(dat$betaN)
    dat.norm <- cbind(dat, muN, betaTN, b=2*abs(betaTN-1/2))
    
    ## some plots
    chrs <- sort(unique(dat.norm$chromosome))
    
    for (cc in seq(along=chrs)) {
        chr <- chrs[cc]
        print(chr)
        
        datCC <- subset(dat.norm, chromosome==chr)
        
        figName <- sprintf("%s,chr%02d,tracks.png", sampleName, chr)
        path <- file.path(figPath, "tracks", dataSet)
        path <- Arguments$getWritablePath(path);
        pathname <- file.path(path, figName)

        if (!file.exists(pathname) || figForce) {
            png(pathname, width=1200, height=800)
            par(mfrow=c(2,1))
            plot(CT~posMb, data=datCC, cex=0.2, ylim=c(0,5), pch=19, xlab="position (Mb)", ylab="copy number")
            plot(betaTN~posMb, data=datCC, cex=0.2, ylim=c(0,1), pch=19, xlab="position (Mb)", ylab="B allele Fraction")
            dev.off()
        }
    }
    figName <- sprintf("%s,C1C2.png", sampleName)
    path <- file.path(figPath, "C1C2", dataSet)
    path <- Arguments$getWritablePath(path);
    pathname <- file.path(path, figName)

    if (!file.exists(pathname)) {  
        fit <- segmentByPairedPSCBS(dat)
        png(pathname, width=800, height=800)
        plotC1C2(fit)
        linesC1C2(fit)
        dev.off()
    }
}


datCC <- subset(dat, chromosome==10)
str(datCC)
fitCC <- segmentByPairedPSCBS(datCC)

plotC1C2(fit)
linesC1C2(fit)
pointsC1C2(fitCC, col=2)
linesC1C2(fitCC, col=2)

library("R.utils");
library("aroma.light");

dataSet <- "GSE29172"
chipType <- "GenomeWideSNP_6"

if (FALSE) {
    ## Define CN regions:
    rpn <- sprintf("preprocessing/%s/05.defineCopyNumberSegments.R", dataSet)
    pn <- system.file(rpn, package="acnr")
    file.exists(pn)
    source(pn)
    str(regDat)
}

datPath <- "wholeGenomeData";
datPath <- Arguments$getReadablePath(datPath);

regPath <- "png/regions"
regPath <- file.path(regPath, dataSet)
regPath <- Arguments$getWritablePath(regPath)

path <- file.path(datPath, sprintf("%s,ASCRMAv2", dataSet), chipType);
path <- Arguments$getReadablePath(path);

patt <- "H1395vsBL1395,([0-9]+).rds"
filenames <- list.files(path, pattern=patt)
pathnames <- file.path(path, filenames)
rm(path)
pct <- as.numeric(gsub(patt, "\\1", filenames))

for (kk in seq(along=pct)) {
    pathname <- pathnames[kk]
    sampleName <- gsub("(.*)\\.rds$", "\\1", filenames[kk])

    print(sampleName)

    dat <- readRDS(pathname)
    dat$posMb <- dat$x/1e6;
    rm(pathname)

    ## run TumorBoost
    betaTN <- normalizeTumorBoost(betaT=dat$betaT,betaN=dat$betaN)
    muN <- callNaiveGenotypes(dat$betaN)
    dat.norm <- cbind(dat, muN, betaTN, b=2*abs(betaTN-1/2))

    ## some plots
    bkp <- function(pos) abline(v=pos, col=5, lwd=2)

    resList <- NULL
    for (rr in 1:nrow(regDat)) {
        chr <- regDat[rr, "chr"]
        reg <- c(regDat[rr, "begin"], regDat[rr, "end"])
        type <- regDat[rr, "type"]
        print(type)

        datCC <- subset(dat.norm, chromosome==chr)
        minR <- reg[1]
        maxR <- reg[2]

        datRR <- subset(datCC, posMb>minR & posMb<maxR)
        str(datRR)

        margin <- Inf
        datRRm <- subset(datCC, posMb>minR-margin & posMb<maxR+margin)
        str(datRRm)

        figName <- sprintf("%s,chr%02d,%s-%s,%s", sampleName, chr, minR, maxR, type)

        tracks <- c("CT", "betaN", "betaT")
        ylabs <- c("Copy number", "Allele B fraction (normal)", "Allele B fraction (tumor)")
        ylims <- rbind(c(0, 5), c(0, 1), c(0, 1))

        for (tt in seq(along=tracks)) {
            track <- tracks[[tt]]
            filename <- sprintf("%s,%s.png", figName, track)
            pathname <- file.path(regPath, filename)
            png(pathname, width=1200, height=400)
            par(mar=c(4.8, 4.8, 0, 0)+0.2, cex.lab=2, cex.axis=2)
            plot(datRRm[["posMb"]], datRRm[[track]], pch=NA, ylim=ylims[tt, ],
                 xlab="position (Mb)", ylab=ylabs[tt])
            pusr <- par("usr")
            rect(minR, pusr[3], maxR, pusr[4], col=6)
            points(datRRm[["posMb"]], datRRm[[track]], ylim=ylims[tt, ],
                   pch=19, col="#333333", cex=0.5)
            dev.off()

            cols <- rep("#333333", nrow(datRRm))
            cols[datRRm[["posMb"]]<minR] <- NA
            cols[datRRm[["posMb"]]>maxR] <- NA
            filename <- sprintf("%s,%s,white.png", figName, track)
            pathname <- file.path(regPath, filename)
            png(pathname, width=1200, height=400)
            par(mar=c(4.8, 4.8, 0, 0)+0.2, cex.lab=2, cex.axis=2)
            plot(datRRm[["posMb"]], datRRm[[track]], pch=NA, ylim=ylims[tt, ],
                 xlab="position (Mb)", ylab=ylabs[tt])
            pusr <- par("usr")
            rect(minR, pusr[3], maxR, pusr[4], col=6)
            points(datRRm[["posMb"]], datRRm[[track]], ylim=ylims[tt, ],
                   pch=19, col=cols, cex=0.5)
            dev.off()
        }

        opos <- order(datRR$x)
        datRRo <- datRR[opos, ]

        if (FALSE) { ## currently not used
            figName <- sprintf("%s,chr%02d,%s-%s,%s,order.png", sampleName, chr, minR, maxR, type)
            pathname <- file.path(regPath, figName)
            png(pathname, width=1200, height=900)
            par(mfrow=c(3,1))
            plot(datRRo$CT, cex=0.2, ylim=c(0,5), pch=19, xlab="position (order)", ylab="copy number")
            plot(datRRo$betaTN, cex=0.2, ylim=c(0,1), pch=19, xlab="position (order)", ylab="B allele Fraction (tumor)")
            plot(datRRo$betaN, cex=0.2, ylim=c(0,1), pch=19, xlab="position (order)", ylab="B allele Fraction (normal)")
            dev.off()
        }
        datSS <- datRRo[, c("CT", "betaTN", "muN", "betaT", "betaN")]
        names(datSS) <- c("c","b","genotype", "bT", "bN")
        datSS <- round(datSS, 3)

        resList[[type]] <- datSS
    }

    if (FALSE) {
        ## Some statistics
        geno <- sapply(resList, FUN=function(dat) table(dat$genotype, useNA="always"))
        geno
        geno/matrix(colSums(geno), nrow(geno), ncol(geno), byrow=TRUE)

        cMeans <- sapply(resList, FUN=function(dat) by(dat, dat$genotype, FUN=function(x) mean(x$c, na.rm=TRUE)))
        bMeans <- sapply(resList, FUN=function(dat) by(dat, dat$genotype, FUN=function(x) mean(2*abs(x$b-1/2), na.rm=TRUE)))

        plot(NA, xlim=c(1, ncol(cMeans)), ylim=range(cMeans))
        for (rr in 1:nrow(cMeans)) points(cMeans[rr, ], pch=19, cex=0.3, col=rr)
        plot(NA, xlim=c(1, ncol(bMeans)), ylim=range(bMeans))
        for (rr in 1:nrow(bMeans)) points(bMeans[rr, ], pch=19, cex=0.3, col=rr)
        c1 <- cMeans*(1-bMeans)/2
        c2 <- cMeans*(1+bMeans)/2
        plot(bMeans[2,], ylim=c(0,1))
        plot(c1[2,], c2[2,], xlim=c(0,2), ylim=c(0,3))
    }
} ## for (kk

library("R.utils");

dataSet <- "GSE13372"
chipType <- "GenomeWideSNP_6"
sampleName <- "HCC1143_GLEYSvsHCC1143BL_GLEYS"

if (FALSE) {
    ## Define CN regions
    regFile <- "05.defineCopyNumberSegments.R"
    pn <- file.path("preprocessing", dataSet, regFile)
    sf <- system.file(pn, package="acnr")
    source(sf)
    str(regDat)
}

regPath <- "cnRegionData";
regPath <- Arguments$getReadablePath(regPath);

ds <- sprintf("%s,ASCRMAv2", dataSet)
chipType <- "GenomeWideSNP_6"

path <- file.path(regPath, ds, chipType);
path <- Arguments$getReadablePath(path);

pattern <- sprintf("%s,([0-9]+),\\(([0-9]),([0-9])\\).rds", sampleName)
filenames <- list.files(path, pattern=pattern)
pcts <- unique(gsub(pattern, "\\1", filenames))

savPath <- Arguments$getWritablePath("inst/extdata")

types <- regDat[["type"]]
datList <- list()
for (pct in pcts) {
    print(pct)
    pattern <- sprintf("%s,%s,(.*).rds", sampleName, pct)
    filenames <- list.files(path, pattern=pattern)
    types <- gsub(pattern, "\\1", filenames)
    
    pathnames <- file.path(path, filenames)
    for (tt in seq(along=types)) {
        pathname <- pathnames[tt]
        typ <- types[tt]
        dat <- readRDS(pathname)
        dat$region <- typ
        dat$cellularity <- as.numeric(pct)/100
        tag <- sprintf("%s,%s", pct, typ)
        datList[[tag]] <- dat
    } 
}
dat <- do.call("rbind", datList)
rownames(dat) <- NULL
str(dat)

dsName <- "GSE13372_HCC1143"
filename <- sprintf("%s.rds", dsName)
pathname <- file.path(savPath, filename)
saveRDS(dat, file=pathname)

## Required local file structure:
## (see http://aroma-project.org/setup for details)
## 
## rawData/
##   GSE29172/
##     GenomeWideSNP_6/
##       GSM721892_PA097_mix100_091027_GenomeWideSNP_6_.CEL
##       GSM721893_PA097_mix30_110329_GenomeWideSNP_6_.CEL
##       GSM721894_PA097_mix50_110329_GenomeWideSNP_6_.CEL
##       GSM721895_PA097_mix70_091027_GenomeWideSNP_6_.CEL
##   GSE26302/
##     GenomeWideSNP_6/
##       GSM645856_PA097_NCI-BL1395_091027_GenomeWideSNP_6_.CEL

library("aroma.affymetrix")
log <- verbose <- Arguments$getVerbose(-8, timestamp=TRUE)
options(digits=4) # Don't display too many decimals.

## Setup raw data set
cdf <- AffymetrixCdfFile$byChipType("GenomeWideSNP_6", tags="Full")
print(cdf)

dataSet <- "GSE29172"
csR <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csR)
resR <- doASCRMAv2(csR, verbose=verbose)

dataSet <- "GSE26302"
csN <- AffymetrixCelSet$byName(dataSet, cdf=cdf)
print(csN)
resN <- doASCRMAv2(csN, verbose=verbose)

## Data can be retrieved from http://cbbp.thep.lu.se/~markus/software/BAFsegmentation/
## genomic DNA of breast carcinoma cells mixed with DNA from lymphoblastoid
## cells at known proportions.  Genotypes are from lymphoblastoid cells.

dataSet <- "GSE11976"
chipType <- "HumanCNV370v1"
tf <- "~/Downloads/CRL2324_dilutionSeries_TableExport.zip"
if (!file.exists(tf)) {
        url <- "http://cbbp.thep.lu.se/~markus/software/BAFsegmentation/CRL2324_dilutionSeries_TableExport.zip"
        download.file(url, tf)
}
dat <- readr::read_tsv(tf)

## Keep only interesting columns
nms <- names(dat)
nms <- gsub("CRL2325\\.", "CRL2324_0pc_Tum\\.", nms)
nms <- gsub("CRL2324\\.", "CRL2324_100pc_Tum\\.", nms)
names(dat) <- nms
nC <- nms[grep("Log R Ratio", nms)]
pcts <- gsub("CRL2324_([0-9]+)pc_Tum.Log R Ratio", "\\1", nC)

datN <- dat[,c("Chr", "Position", "CRL2324_0pc_Tum.GType")]
names(datN) <-  c("chromosome", "position", "genotype")
                 
BAF <- sprintf("CRL2324_%spc_Tum.%s", pcts, "B Allele Freq")
datBAF <- dat[, BAF]
names(datBAF) <- sprintf("BAF_%s", pcts)

LRR <- sprintf("CRL2324_%spc_Tum.%s", pcts, "Log R Ratio")
datLRR <- dat[, LRR]
names(datLRR) <- sprintf("LRR_%s", pcts)

df <- cbind(datN, datLRR, datBAF)

## Map genotype to 0,1/2,1
fgeno <- gsub("A", "", df$genotype)
fgeno[fgeno=="NC"] <- NA
df$muN <- nchar(fgeno)/2

datPath <- "wholeGenomeData"; ## A symbolic link to "/home/share/Data/wholeGenomeData"
datPath <- Arguments$getReadablePath(datPath);
ds <- sprintf("%s,BeadStudio", dataSet)
path <- file.path(datPath, ds, chipType);
rm(ds);
path <- Arguments$getWritablePath(path);

## save  
fileName <- sprintf("CRL2324_dilutionSeries.rds", dataSet)
pathname <- file.path(path, fileName)
saveRDS(df, file=pathname)

library(R.utils)
source("00.defineCopyNumberSegments.R")
str(regDat)

datI <- readRDS("CRL2324_dilutionSeries.rds")
datI$posMb <- datI$Position/1e6;
## Define genotypes


pct <- c("100","79", "50", "34", "0") 
dataSet <- "GSE11976,BAF"
chipType <- "HumanCNV370v1"

for(pp in pct){
    savPath <- "img"
    savPath <- Arguments$getWritablePath(savPath)
    path <- file.path(savPath, dataSet, chipType);
    path <- Arguments$getWritablePath(path)
    sampleName <- sprintf("CRL2324,BAF,%s",pp)
    for (rr in 1:nrow(regDat)) {
        chr <- regDat[rr, "chr"]
        print(chr)
        reg <- c(regDat[rr, "begin"], regDat[rr, "end"])
        type <- regDat[rr, "type"]
        print(type)
        print(reg)
        datCC <- subset(datI, chromosome==chr)
        datRR <- subset(datCC, posMb>=reg[1] & posMb<=reg[2])
        opos <- order(datRR$posMb)
        datRRo <- datRR[opos, ]
        datRRo <- na.omit(datRRo)
        
        columns <- c(sprintf("logR_%s",pp), sprintf("baf_%s",pp), "muN")
        datSS <- na.omit(datRRo[, columns])
        names(datSS) <- c("c","b","genotype")
        ## Transformation logR to tcn and baf to beta 
        datSS$c <- 2^(datSS$c + 1)
        tgb <- tan(datSS$b*pi/2)
        datSS$b <- tgb/(1+tgb)
        datSS <- round(datSS, 3)
        filename <- sprintf("%s,CT,Baf,%s.pdf", sampleName, type)
        pathname <- file.path(path,filename)
        pdf(pathname)
        par(mfrow=c(2,1))
        plot(datSS$c,cex = 0.5, main = type, ylim = c(0,3))
        plot(datSS$b,cex = 0.5)
        dev.off()
    }
}

library("R.utils");

dataSet <- "GSE13372"

if (FALSE) {
    ## Define CN regions
    regFile <- "05.defineCopyNumberSegments.R"
    pn <- file.path("preprocessing", dataSet, regFile)
    sf <- system.file(pn, package="acnr")
    source(sf)
    str(regDat)
}

datPath <- "wholeGenomeData";
datPath <- Arguments$getReadablePath(datPath);

dataSet <- "GSE13372,ASCRMAv2"
chipType <- "GenomeWideSNP_6"

path <- file.path(datPath, dataSet, chipType);
path <- Arguments$getReadablePath(path);

filenames <- list.files(path, pattern="HCC1143_GLEYSvsHCC1143BL_GLEYS,([0-9]+).rds")
sampleNames <- gsub("(.*)\\.rds$", "\\1", filenames)

pathnames <- file.path(path, filenames)

for (kk in seq(along=filenames)) {
  filename <- filenames[kk]
  sampleName <- gsub("(.*)\\.rds$", "\\1", filename)
  pathname <- file.path(path, filename)
  
  print(sampleName)
  pathname <- pathnames[kk];
  
  dat <- readRDS(pathname)
  dat$posMb <- dat$x/1e6;
  rm(pathname)
  
  ## run TumorBoost
  muN <- aroma.light::callNaiveGenotypes(dat$betaN)
  gens <- table(muN, exclude = NULL)
  stopifnot(all(c("0", "0.5", "1") %in% names(gens)))  ## sanity check: are all genotypes represented?  
  betaTN <- aroma.light::normalizeTumorBoost(betaT=dat$betaT,betaN=dat$betaN, muN=muN)
  
  dat.norm <- cbind(dat, muN, betaTN, b=2*abs(betaTN-1/2))
  
  regPath <- "png/regions"
  regPath <- file.path(regPath, dataSet)
  regPath <- Arguments$getWritablePath(regPath)
  
  savPath <- "cnRegionData"
  savPath <- Arguments$getWritablePath(savPath)
  path <- file.path(savPath, dataSet, chipType);
  path <- Arguments$getWritablePath(path)
  
  bkp <- function(pos) abline(v=pos, col=5, lwd=2)
  
  for (rr in 1:nrow(regDat)) {
    chr <- regDat[rr, "chr"]
    reg <- c(regDat[rr, "begin"], regDat[rr, "end"])
    type <- regDat[rr, "type"]
    print(type)
    
    datCC <- subset(dat.norm, chromosome==chr)
    datRR <- subset(datCC, posMb>reg[1] & posMb<reg[2])
    str(datRR)
    
    opos <- order(datRR$x)
    datRRo <- datRR[opos, ]
    
    datSS <- datRRo[, c("CT", "betaTN", "muN", "betaT", "betaN")]
    names(datSS) <- c("c","b","genotype", "bT","bN")
    datSS <- round(datSS, 3)
    
    filename <- sprintf("%s,%s.rds", sampleName, type)
    pathname <- file.path(path,filename)
    saveRDS(datSS, file=pathname)
  }
}

## ---- include=FALSE------------------------------------------------------
library("knitr")
opts_chunk$set(
dev='png', fig.width=5, fig.height=5
)

## ------------------------------------------------------------------------
library("acnr")
dataSets <- listDataSets()
dataSets

## ------------------------------------------------------------------------
tf <- 1
regList <- lapply(dataSets, FUN=function(ds) {
    regDat <- loadCnRegionData(dataSet=ds, tumorFraction=tf) 
    regs <- regDat[["region"]]
})
names(regList) <- dataSets

allregs <- unique(unlist(regList))
tab <- sapply(allregs, FUN=function(reg) {
    sapply(regList, FUN=function(rr) sum(rr==reg))
})
cap <- paste("Size of annotated copy-number regions for each of the", 
            length(dataSets), "data sets.")
knitr::kable(tab, caption=cap)

## ------------------------------------------------------------------------
sessionInfo()

## Adapted from http://aroma-project.org/vignettes/PairedPSCBS-lowlevel
library("aroma.affymetrix")

dataSet <- "GSE13372";
chipType <- "GenomeWideSNP_6"

tags <- "ACC,ra,-XY,BPN,-XY,AVG,FLN,-XY"
ds <- AromaUnitTotalCnBinarySet$byName(dataSet, tags=tags, chipType=chipType)
length(ds)

## Extract only one tumor and two matching normals
nms <- c(T="GSM337641", N="GSM337662", R="GSM337663")
dsE <- extract(ds, indexOf(ds, nms))
tumorName <- "HCC1143_GLEYS"
normalName <- "HCC1143BL_GLEYS"
sampleName <- "HCC1143"

## Naming
## Extract (total,beta) estimates for the tumor-normal pair
dat <- extractPSCNArray(dsE);
dn3 <- dimnames(dat)[[3]]
dimnames(dat)[[3]] <- names(nms)[match(dn3, nms)]

## Get (chromosome, position) annotation data
ugp <- getAromaUgpFile(dsE);
chromosome <- ugp[,1,drop=TRUE];
x <- ugp[,2,drop=TRUE];

## Total intensities and Allele B fractions for the normal
thetaN <- dat[,"total", "R"];
betaN <- dat[,"fracB", "R" ];

datPath <- "wholeGenomeData";
datPath <- Arguments$getWritablePath(datPath);
chipType <- getChipType(dsT, full=FALSE)
dsName <- getName(dsT)
dataSet <- sprintf("%s,ASCRMAv2", dataSet)
path <- file.path(datPath, dataSet, chipType);
path <- Arguments$getWritablePath(path);


idxs <- c("N", "T")
for (ss in idxs) {
    if (ss == "N") {
        pairName <- sprintf("%svs%s,0", tumorName, normalName)
    } else if (ss=="T") {
        pairName <- sprintf("%svs%s,100", tumorName, normalName)
    }
    ## Total CNs for the tumor relative to the matched normal
    CT <- 2 * dat[,"total", ss] / thetaN;
    
    ## Allele B fractions for the tumor
    betaT <- dat[,"fracB", ss];
    
    ## Setup data structure
    df <- data.frame(chromosome=chromosome, x=x, CT=CT, betaT=betaT, betaN=betaN);

    dfC <- subset(df, !is.na(df$chromosome) & !is.na(df$x))
    str(dfC)
    
    ## save  
    fileName <- sprintf("%s.rds", pairName)
    pathname <- file.path(path, fileName)
    saveRDS(dfC, file=pathname)
    
    ## chromosome by chromosome
    if (FALSE) {
        for (cc in 1:24) {
            print(cc)
            fileName <- sprintf("%s,chr=%02d.rds", pairName, cc)
            pathname <- file.path(path, fileName)
            saveRDS(dfC, file=pathname)
            
            datCC <- subset(dfC, chromosome==cc)
            o <- order(datCC$x)
            datCC <- datCC[o, ]
            str(datCC)
            save(datCC, file=pathname)
        }
    }
}

library("aroma.core");
verbose <- Arguments$getVerbose(-8, timestamp=TRUE);
ar <- AromaRepository(verbose=TRUE);

verbose && enter(verbose, "Downloading annotation data");

chipType <- "GenomeWideSNP_6";
tags <- "Full";
verbose && cat(verbose, "Chip type: ", chipType);

pathname <- downloadACS(ar, chipType, tags=".*");
verbose && cat(verbose, "ACS: ", pathname);

pathname <- downloadCDF(ar, chipType, tags=tags);
verbose && cat(verbose, "CDF: ", pathname);

pathname <- downloadUGP(ar, chipType, tags=c(tags, "na31,hg19", ".*"));
verbose && cat(verbose, "UGP: ", pathname);

pathname <- downloadUFL(ar, chipType, tags=c(tags, "na31,hg19", ".*"));
verbose && cat(verbose, "UFL: ", pathname);

verbose && exit(verbose);

---
title: "Annotated data sets contained in the `acnr` package"
author: "M. Pierre-Jean, P. Neuvial"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Annotated data sets contained in the `acnr` package}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE}
library("knitr")
opts_chunk$set(
dev='png', fig.width=5, fig.height=5
)
```

The `acnr` package is a data package containing SNP array data from different platforms (Affymetrix and Immumina) and different types of copy-number regions. These regions were identified manually by the authors of the package and may be used to generate realistic data sets with known truth.

This package was initially built to serve as a data package for the `jointseg` package which is currently available from  [github](https://github.com/mpierrejean/jointseg).


Currently the `acnr` package contains three data sets curated from GEO:

```{r}
library("acnr")
dataSets <- listDataSets()
dataSets
```

This vignette provides basic summary statistics of these data sets. 


## Description of the annotated data sets

```{r}
tf <- 1
regList <- lapply(dataSets, FUN=function(ds) {
    regDat <- loadCnRegionData(dataSet=ds, tumorFraction=tf) 
    regs <- regDat[["region"]]
})
names(regList) <- dataSets

allregs <- unique(unlist(regList))
tab <- sapply(allregs, FUN=function(reg) {
    sapply(regList, FUN=function(rr) sum(rr==reg))
})
cap <- paste("Size of annotated copy-number regions for each of the", 
            length(dataSets), "data sets.")
knitr::kable(tab, caption=cap)
```

## Session information

```{r}
sessionInfo()
```
